﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace MsSqlServices
{
    public class ActivityServices : IServices.IActivityServices, Chocolate.Common.Interface.IDataToEntity<Model.Activity>
    {
        public int Insert(Model.Activity activity)
        {
            using (SqlConnection conn = new SqlConnection())
            {
                conn.ConnectionString = "Data Source=.;Initial Catalog=aspnetmvc3;User ID=sa;Password=niyouzhu";
                conn.Open();
                SqlCommand cmd = conn.CreateCommand();
                string sql = @"INSERT INTO Activitys
                            (Name)
                            VALUES   (@Name)";
                cmd.CommandText = sql;
                List<SqlParameter> parameters = new List<SqlParameter>();
                parameters.Add(new SqlParameter("@Name", activity.Name));
                cmd.Parameters.AddRange(parameters.ToArray());
                cmd.CommandType = CommandType.Text;
                return cmd.ExecuteNonQuery();
            }
        }


        public int Delete(Model.Activity activity)
        {
            using (SqlConnection conn = new SqlConnection())
            {
                conn.ConnectionString = "Data Source=.;Initial Catalog=aspnetmvc3;User ID=sa;Password=niyouzhu";
                conn.Open();
                SqlCommand cmd = conn.CreateCommand();
                string sql = @"DELETE FROM Activitys
                            WHERE   (Id = @Id)";
                cmd.CommandText = sql;
                List<SqlParameter> parameters = new List<SqlParameter>();
                parameters.Add(new SqlParameter("@Name", activity.Id));
                cmd.Parameters.AddRange(parameters.ToArray());
                cmd.CommandType = CommandType.Text;
                return cmd.ExecuteNonQuery();
            }
        }

        public int Update(Model.Activity activity)
        {
            using (SqlConnection conn = new SqlConnection())
            {
                conn.ConnectionString = "Data Source=.;Initial Catalog=aspnetmvc3;User ID=sa;Password=niyouzhu";
                conn.Open();
                SqlCommand cmd = conn.CreateCommand();
                string sql = @"UPDATE  Activitys
                            SET         Name = @Name
                            WHERE   (Id = @Id)";
                cmd.CommandText = sql;
                List<SqlParameter> parameters = new List<SqlParameter>();
                parameters.Add(new SqlParameter("@Name", activity.Name));
                parameters.Add(new SqlParameter("@Id", activity.Id));
                cmd.Parameters.AddRange(parameters.ToArray());
                cmd.CommandType = CommandType.Text;
                return cmd.ExecuteNonQuery();
            }
        }

        public List<Model.Activity> SelectWhereId(int id)
        {
            using (SqlConnection conn = new SqlConnection())
            {
                conn.ConnectionString = "Data Source=.;Initial Catalog=aspnetmvc3;User ID=sa;Password=niyouzhu";
                conn.Open();
                SqlCommand cmd = conn.CreateCommand();
                string sql = @"SELECT   Id, Name
                            FROM      Activitys
                            WHERE   (Id = @Id)";
                cmd.CommandText = sql;
                List<SqlParameter> parameters = new List<SqlParameter>();
                parameters.Add(new SqlParameter("@Id", id));
                cmd.Parameters.AddRange(parameters.ToArray());
                cmd.CommandType = CommandType.Text;
                SqlDataReader reader = cmd.ExecuteReader();


                List<Model.Activity> activitys = ConvertToList(reader);
                return activitys;
            }
        }

        public List<Model.Activity> ConvertToList(System.Data.DataTable data)
        {
            List<Model.Activity> activitys = new List<Model.Activity>();
            System.Data.DataTableReader reader = data.CreateDataReader();
            for (int i = 0; i < data.Rows.Count; i++)
            {
                if (reader.Read())
                {
                    activitys.Add(new Model.Activity() { Id = Convert.ToInt64(reader["Id"]), Name = Convert.ToString(reader["Name"]) });
                }
            }
            return activitys;
        }

        public List<Model.Activity> ConvertToList(System.Data.SqlClient.SqlDataReader data)
        {
            System.Data.DataTable table = new System.Data.DataTable();
            table.Load(data);
            return ConvertToList(table);
        }

        public List<Model.Activity> ConvertToList(System.Data.DataRow row)
        {
            throw new NotImplementedException();
        }


        public List<Model.Activity> ConvertToList(DataTableReader data)
        {
            System.Data.DataTable table = new System.Data.DataTable();
            table.Load(data);
            return ConvertToList(table);
        }
    }
}
